require_relative 'player'

module StudioGame
	class ClumsyPlayer < Player
		attr_reader :boost

		def initialize (name, health=100)
			super(name, health)
			@boost = (1..10).to_a.sample
		end

		def w00t
			@boost.times { super }
		end

		def found_treasure(treasure)
			damaged_treasue = Treasure.new(treasure.name, treasure.points / 2)
			super (damaged_treasue)
		end
	end
end



if __FILE__ == $0
  clumsy = ClumsyPlayer.new("klutz")  
  
  hammer = Treasure.new(:hammer, 50)
  clumsy.found_treasure(hammer)
  clumsy.found_treasure(hammer)
  clumsy.found_treasure(hammer)
  puts clumsy.boost
  
  crowbar = Treasure.new(:crowbar, 400)
  clumsy.found_treasure(crowbar)
  
  clumsy.each_found_treasure do |treasure|
    puts "#{treasure.points} total #{treasure.name} points"
  end
  puts "#{clumsy.points} grand total points"
end
